<!DOCTYPE html>
<html>

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, shrink-to-fit=no">
    <title>Home - Brand</title>
    <link rel="stylesheet" href="../assets/bootstrap/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Montserrat:400,400i,700,700i,600,600i">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Audiowide&amp;display=swap">
    <link rel="stylesheet" href="../assets/css/codemirror.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/baguettebox.js/1.10.0/baguetteBox.min.css">
    <link rel="stylesheet" href="../assets/css/Login-Form-Clean.css">
    <link rel="stylesheet" href="../assets/css/Navigation-Clean.css">
    <link rel="stylesheet" href="../assets/css/Navigation-with-Button.css">
    <link rel="stylesheet" href="../assets/css/Rehoboam-Elms.css">
    <link rel="stylesheet" href="../assets/css/Rehoboam-Nav.css">
    <link rel="stylesheet" href="../assets/css/vanilla-zoom.min.css">
</head>

<body><script src="https://cdn.socket.io/3.1.3/socket.io.min.js" integrity="sha384-cPwlPLvBTa3sKAgddT6krw0cJat7egBga3DJepJyrLl4Q9/5WLra3rrnMcyTyOnh" crossorigin="anonymous"></script>
<script src="../models/codemirror/codemirror.js"></script>
<script src="../models/codemirror/javascript/javascript.js" type="text/javascript" charset="utf-8"></script>
    <nav class="navbar navbar-light navbar-expand-md navigation-clean-button">
        <div class="container"><a class="navbar-brand" href="/index.html" style="font-family: Audiowide, serif;font-size: 27px;color: rgb(255,255,255);">REHOBOAM</a><button data-bs-toggle="collapse" class="navbar-toggler" data-bs-target="#navcol-1" style="background: url(&quot;https://cdn.bootstrapstudio.io/placeholders/1400x800.png&quot;);"><span class="visually-hidden">Toggle navigation</span><span class="navbar-toggler-icon"></span></button>
            <div class="collapse navbar-collapse" id="navcol-1">
                <ul class="navbar-nav me-auto"></ul><span class="navbar-text actions"> <a class="login" href="login.html">Log In</a><a class="btn btn-light action-button" role="button" href="#">Sign Up</a></span>
            </div>
        </div>
    </nav>
    <main class="page landing-page">
        <section class="clean-block clean-form dark" style="background: #16102c;height: 700px;padding-bottom: 0;">
            <div class="container main_container" style="font-size: 14px;">
                <div class="row">
                    <div class="col-md-6 outer_results_container" style="position: relative;overflow: auto;">
                        <div class="row">
                            <div class="col">
                                <ul class="list-group">
                                    <li class="list-group-item">
                                        <div class="row">
                                            <div class="col">
                                                <h3 id="domain_name"></h3><label class="form-label" id="lbl_language"></label>
                                            </div>
                                            <div class="col" style="max-width: 20%;">
                                                <div class="form-check" style="margin-top: 6px;"><input type="checkbox" id="chk_activate" class="form-check-input"><label class="form-label form-check-label" for="chk_activate">Activate</label></div>
                                            </div>
                                        </div>
                                    </li>
                                    <li class="list-group-item">
                                        <div class="row">
                                            <div class="col"><label class="form-label" for="txt_crawling_period">Crawling period [ms]</label><input type="text" id="txt_crawling_period"></div>
                                        </div>
                                    </li>
                                </ul>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col" style="padding-right: 5px;">
                                <ul class="list-group results_container" id="categories_container"></ul>
                            </div>
                        </div>
                    </div>
                    <div class="col-md-6" style="position: relative;overflow: auto;padding-left: 20px;">
                        <div class="row" style="background: #e8f0ff;border-radius: 10px;height: 100%;">
                            <div class="col">
                                <div class="row" style="padding-top: 15px;">
                                    <div class="col" style="text-align: left;">
                                        <h2 style="color: #000000;">Control Json</h2>
                                    </div>
                                    <div class="col button_col"><button class="btn btn-primary" id="btn_save" type="button">Save</button></div>
                                </div>
                                <div class="row" style="padding-top: 20px;">
                                    <div class="col">
                                        <div style="padding-left: 10px;height: inherit;">
                                            <ul class="nav nav-tabs" role="tablist">
                                                <li class="nav-item" role="presentation"><a class="nav-link active" role="tab" data-bs-toggle="tab" href="#tab_masterpage">Master page</a></li>
                                                <li class="nav-item" role="presentation"><a class="nav-link" role="tab" data-bs-toggle="tab" href="#tab_articlepage">Article page</a></li>
                                            </ul>
                                            <div class="tab-content" style="position: relative;overflow: auto;height: initial;">
                                                <div class="tab-pane active editor_tab" role="tabpanel" id="tab_masterpage">
                                                    <div class="row" style="padding-bottom: 10px;padding-top: 10px;">
                                                        <div class="col button_col"><button class="btn btn-primary" id="btn_mptest" type="button">Test</button></div>
                                                    </div>
                                                    <div class="row">
                                                        <div class="col">
                                                            <div style="position: relative;overflow: auto;height: 100%;width: 100%;"><textarea id="mp_editor" class="editor" style="&quot;position: absolute;left: 0;top: 0;"></textarea></div>
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="tab-pane editor_tab" role="tabpanel" id="tab_articlepage">
                                                    <div class="row" style="padding-bottom: 10px;padding-top: 10px;">
                                                        <div class="col button_col"><button class="btn btn-primary" id="btn_aptest" type="button">Test</button></div>
                                                    </div>
                                                    <div class="row">
                                                        <div class="col">
                                                            <div style="position: relative;overflow: auto;height: 100%;width: 100%;"><textarea id="ap_editor" class="editor" style="&quot;position: absolute;left: 0;top: 0;"></textarea></div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </section>
    </main><script>
    function create_popup () {

        // var container = document.getElementById('categories_container');

        var popup_container = document.createElement('div');
        // new_cat.className = 'container popup';
        popup_container.setAttribute('class', 'container popup');
        popup_container.setAttribute('id', 'popup_container');

        var btn_row = document.createElement("div");
        // btn_row.className = 'row';
        // btn_row.style.height = '5%';
        btn_row.setAttribute('class', 'row');
        btn_row.setAttribute('style', 'height: 5%');

        var btn_col = document.createElement("div");
        // btn_col.className = 'col';
        // btn_col.style.text-align = 'right';
        // btn_col.style.margin-right = '20px';
        // btn_col.style.margin-top = '7px';
        btn_col.setAttribute('class', 'col');
        btn_col.setAttribute('style', 'text-align: right;margin-right: 20px;margin-top: 7px;');

        var btn_popup_close = document.createElement('button');
        btn_popup_close.setAttribute('id', 'btn_popup_close');
        btn_popup_close.setAttribute('class', 'btn btn-primary');
        btn_popup_close.setAttribute('type', 'button');
        btn_popup_close.setAttribute('style', 'width: 20px;height: 20px;border-radius: 10;padding: 0px;font-size: 10px;');
        btn_popup_close.innerHTML = 'X';
        btn_popup_close.addEventListener("click", function (e){         delete_popup();
        });

        btn_col.appendChild(btn_popup_close);
        btn_row.appendChild(btn_col);
        popup_container.appendChild(btn_row);

        var content_row = document.createElement("div");
        content_row.setAttribute('class', 'row');
        content_row.setAttribute('style', 'height: 95%; position: relative; overflow: auto;');

        var content_col = document.createElement("div");
        content_col.setAttribute('class', 'col');
        content_col.setAttribute('style', 'margin: 20px;margin-top: 0px;');

        var article_content_container = document.createElement("ul");
        article_content_container.setAttribute('class', 'list-group');
        article_content_container.setAttribute('style', 'padding-top: 20px;');
        article_content_container.setAttribute('id', 'popup_content_container');

        content_col.appendChild(article_content_container);
        content_row.appendChild(content_col);
        popup_container.appendChild(content_row);

        var body = document.body;
        body.appendChild(popup_container);

        return article_content_container;
    }

    function delete_popup () {
        var popup = document.getElementById('popup_container');
        popup.parentNode.removeChild(popup);
    }
</script><script>
    function populate_masterpage_results (container, content_json) {

        var domain = document.getElementById('domain_name');
        domain.innerHTML = content_json.domain;

        var language = document.getElementById('lbl_language');
        language.innerHTML = content_json.language;

        var new_cat = document.createElement('li');
        new_cat.className = 'list-group-item';

        var cat_row = document.createElement("div");
        cat_row.className = 'row';
        var cat_col = document.createElement("div");
        cat_col.className = 'col';

        var cat_header = document.createElement("h4");
        var cat_header_text = document.createTextNode(content_json.category.toUpperCase());

        cat_header.appendChild(cat_header_text);
        cat_col.appendChild(cat_header);
        cat_row.appendChild(cat_col);
        new_cat.appendChild(cat_row);

        var items_row = document.createElement("div");
        items_row.className = 'row';
        var items_col = document.createElement("div");
        items_col.className = 'col';
        var items_container = document.createElement("ul");
        items_container.className = 'list-group';

        var items_array = content_json.items;

        for (var item_json of items_array) {
            var item_container = document.createElement("li");
            item_container.setAttribute('class', 'list-group-item content_item');
            item_container.setAttribute('id', uuidv4());

            //Add category
            item_add_component (item_container,
                                  'div',
                                  cat_header.innerHTML,
                                name='category');

            //Add header
            item_add_component (item_container,
                                  'div',
                                  item_json.header,
                                name='header');

            //Add description
            item_add_component (item_container,
                                  'div',
                                  item_json.description,
                               name='description');

            // //Add domain
            // item_add_component (item_container,
            //                       'p',
            //                       section_json.domain,
            //                    name='domain');

            //Add url
            item_add_component (item_container,
                                  'a',
                                  item_json.url,
                                'url',
                                item_json.url);

            //Add timestamp
            item_add_component (item_container,
                                  'div',
                                  item_json.timestamp,
                               'timestamp');

            //Add page_type_id
            item_add_component (item_container,
                                  'div',
                                  item_json.page_type_id,
                               'page_type_id');

            items_container.appendChild(item_container);

            //Add checkbox
            item_add_chk_component (item_container,
                                  'Check to test page',
                                   'totest');

            items_container.appendChild(item_container);

        }

        items_col.appendChild(items_container);
        items_row.appendChild(items_col);
        new_cat.appendChild(items_row);
        container.appendChild(new_cat);

    }

    function populate_articlepage_results (container, content_json) {

        var item_container = document.createElement("li");
        item_container.setAttribute('class', 'list-group-item content_item');
        item_container.setAttribute('id', uuidv4());

        //Add domain
        item_add_component (item_container,
                              'div',
                              content_json.domain,
                            name='domain');

        //Add url
        item_add_component (item_container,
                              'a',
                              content_json.url,
                            'url',
                            content_json.url);

        //Add category
        item_add_component (item_container,
                              'div',
                              content_json.category,
                            name='category');

        //Add author
        item_add_component (item_container,
                              'div',
                              content_json.author,
                            name='author');

        //Add publishing date
        item_add_component (item_container,
                              'div',
                              content_json.publishing_date,
                            name='publishing_date');

        //Add header
        item_add_component (item_container,
                              'div',
                              content_json.header,
                            name='header');

        //Add article body
        item_add_component (item_container,
                              'div',
                              content_json.article_body,
                           name='article_body');

        container.appendChild(item_container);
    }

    function item_add_component (item_container,
                                  component_tag,
                                  component_text,
                                  name=false,
                                  href=false) {
        //Add component
        var row = document.createElement("div");
        row.className = 'row';
        var col = document.createElement("div");
        col.className = 'col';
        var comp = document.createElement(component_tag);
        var comp_text = document.createTextNode(component_text);
        if (href) {
            comp.href = href;
        };

        if (name) {
            comp.setAttribute('name', name);
        };

        comp.appendChild(comp_text);
        col.appendChild(comp);
        row.appendChild(col);
        item_container.appendChild(row);
    }

    function item_add_chk_component (item_container,
                                     label_text,
                                     name=false) {
        //Add component

        var row = document.createElement("div");
        row.setAttribute('class', 'row');

        var col = document.createElement("div");
        col.setAttribute('class', 'col');

        var container = document.createElement("div");
        container.setAttribute('class', 'form-check');

        var comp = document.createElement('input');
        comp.setAttribute('type', 'checkbox');
        comp.setAttribute('class', 'form-check-input');
        comp.setAttribute('id', uuidv4());
        if (name) {
            comp.setAttribute('name', name);
        };

        var comp_label = document.createElement('label');
        comp_label.setAttribute('class', 'form-check-label');
        comp_label.setAttribute('for', comp.id);
        comp_label.innerHTML = label_text;

        container.appendChild(comp_label);
        container.appendChild(comp);
        col.appendChild(container);
        row.appendChild(col);
        item_container.appendChild(row);
    }

    function uuidv4() {
        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
            var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
            return v.toString(16);
        });
    }
</script><script src="../assets/js/socket_connector.js"></script>
<script>
    var mp_editor = CodeMirror.fromTextArea(document.getElementById("mp_editor"), {
        lineNumbers: true,
        mode: "javascript"
    });

    var ap_editor = CodeMirror.fromTextArea(document.getElementById("ap_editor"), {
        lineNumbers: true,
        mode: "javascript"
    });

    var editor_json = {};
    var btn_mptest = document.getElementById("btn_mptest");
    var btn_aptest = document.getElementById("btn_aptest");
    var btn_save = document.getElementById("btn_save");
    var domain_name_container = document.getElementById("domain_name");
    var language_container = document.getElementById("lbl_language");
    var chk_activate = document.getElementById("chk_activate");
    var txt_crawling_period = document.getElementById("txt_crawling_period");

    mp_editor.on("change", function() {
        editor_json = JSON.parse(mp_editor.getValue())
        domain_name_container.innerHTML = editor_json.domain;
        language_container.innerHTML = editor_json.language;
    });

    btn_mptest.addEventListener("click", function (e){
        container = document.getElementById('categories_container');
        container.innerHTML = '';
        editor_json = JSON.parse(mp_editor.getValue());
        console.log(editor_json);
        socket.emit("signal", {
            "object":"crawler",
            "action":"test",
            "params":{
                "object": "masterpage",
                "action": "test",
                "control_json": editor_json
            }
        });
    });

    btn_aptest.addEventListener("click", function (e){

        var article_content_container = create_popup();
        var domain = document.getElementById('domain_name').innerHTML;
        var language = document.getElementById('lbl_language').innerHTML;
        var content_items = document.getElementsByClassName('list-group-item content_item');

        var items_totest = [];
        for (var item of content_items) {
            var chk = item.querySelector('input[name="totest"]');
            if (chk.checked) {
                var item_json = {
                        "category": item.querySelector('div[name="category"]').innerHTML,
                        "url": item.querySelector('a[name="url"]').innerHTML,
                        "page_type_id": item.querySelector('div[name="page_type_id"]').innerHTML
                    };
                items_totest.push(item_json);
            };
        };

        var items_json = {"domain": domain,
                          "language": language,
                          "items": items_totest};

        var control_json = JSON.parse(ap_editor.getValue());

        console.log(items_json, control_json);

        socket.emit("signal", {
            "object":"crawler",
            "action":"test",
            "params":{
                "object": "articlepage",
                "action": "test",
                "items_json": items_json,
                "control_json": control_json
            }
        });
    });

    btn_save.addEventListener("click", function (e){
        crawler_id = localStorage.getItem("crawler_id");
        mp_editor_json = JSON.parse(mp_editor.getValue());
        ap_editor_json = JSON.parse(ap_editor.getValue());
        if (chk_activate.checked) {
            inactive = 0;
        } else {
            inactive = 1;
        }
        if (crawler_id === "0") {
            action = "create";
        } else {
            action = "update";
        }
        // console.log(editor_json);
        socket.emit("signal", {
            "object":"crawler",
            "action":action,
            "params":{
                "crawler_id": crawler_id,
                "domain_name": domain_name_container.innerHTML,
                "masterpage_json": mp_editor_json,
                "articlepage_json": ap_editor_json,
                "crawling_period": txt_crawling_period.value,
                "inactive": inactive
            }
        });
    });

    // chk_activate.addEventListener('change', function() {
    //     if (this.checked) {
    //         alert("It's deactivated");
    //         socket.emit("signal", {
    //             "object":"crawler",
    //             "action":"activate",
    //             "params":{}
    //         });
    //     } else {
    //         alert("It's activated");
    //         socket.emit("signal", {
    //             "object":"crawler",
    //             "action":"deactivate",
    //             "params":{}
    //         });
    //     }
    // });

    function populate_crawler (crawler_data) {
        var domain_name = document.getElementById("domain_name");
        var language = document.getElementById("lbl_language");
        var txt_crawling_period = document.getElementById("txt_crawling_period");
        var chk_activate = document.getElementById("chk_activate");

        var domain_name_text = crawler_data.domain_name;
        var txt_crawling_period_text = crawler_data.crawling_period;
        var chk_activate_value = crawler_data.inactive;
        var masterpage_json = crawler_data.masterpage_json;
        var articlepage_json = crawler_data.articlepage_json;

        domain_name.innerHTML = domain_name_text;
        language.innerHTML = domain_name_text;
        txt_crawling_period.value = txt_crawling_period_text;
        if (chk_activate_value === 0) {
            chk_activate.checked = true;
        } else {
            chk_activate.checked = false;
        }
        //inserttext_toeditor(mp_editor, masterpage_json);
        //inserttext_toeditor(ap_editor, articlepage_json);
        mp_editor.setValue(JSON.stringify(masterpage_json, null, 2));
        ap_editor.setValue(JSON.stringify(articlepage_json, null, 2));
    }

    // function inserttext_toeditor(editor, text) {
    //     var doc = editor.getDoc();
    //     var cursor = doc.getCursor();
    //     doc.replaceRange(text, cursor);
    // }

    socket.on("masterpage_crawled", function(message) {
        console.log(message);
        if (message.crawler_output === '1') {
            alert('Test finished');
        } else {
            var masterpage_res_container = document.getElementById('categories_container');
            populate_masterpage_results(masterpage_res_container, message);
        }
    });

    socket.on("articlepage_crawled", function(message) {
        console.log(message);
        if (message.crawler_output === '1') {
            alert('Test finished');
        } else {
            populate_articlepage_results(document.getElementById('popup_content_container'),
                       message);
        }
    });

    socket.on("test_completed", function(message) {
        console.log(message);
        alert('Test completed');
    });

    socket.on("crawler_created", function(message) {
        alert("Crawler created. ID: ", message.crawler_id);
        localStorage.setItem("crawler_id", message.crawler_id);
        console.log(message);
    });

    socket.on("crawler_updated", function(message) {
        alert("Crawler updated. ID: ", message.crawler_id);
        localStorage.setItem("crawler_id", message.crawler_id);
        console.log(message);
    });

    socket.on("crawler_got", function(message) {
        alert("Got crawler. ID: ", message.crawler_data.crawler_id);
        console.log(message);
        populate_crawler(message.crawler_data);
        console.log(message);
    });

    socket.on("command_failed", function(message) {
        alert("Command failed!");
    });

    window.onload = function () {
        var crawler_id = localStorage.getItem("crawler_id");
        alert(crawler_id)
        if (crawler_id !== "0") {
            socket.emit("signal", {
                "object":"crawler",
                "action":"get",
                "params":{"crawler_id":crawler_id}
            });
        }

    }
</script><style>
    .CodeMirror {
        height: 470px;
    }
    .results_container {
        max-height: 470px;
    }

    .main_container {
        height: 100%;
        padding-top: 15px;
        padding-bottom: 15px;
    }

    .clean-block {
        padding-bottom: none;
    }

    .content_item {
        background-color: #ccd7ff;
        border: solid;
    }
</style>
    <footer class="page-footer" style="background: #090a14;padding-top: 0px;">
        <div class="container">
            <div class="row" style="transform: scale(1);">
                <div class="col-sm-3">
                    <h5 style="color: rgb(116,123,130);">Get started</h5>
                    <ul>
                        <li><a href="#">Home</a></li>
                        <li><a href="#">Sign up</a></li>
                    </ul>
                </div>
                <div class="col-sm-3">
                    <h5 style="color: rgb(116,123,130);">About us</h5>
                    <ul>
                        <li><a href="#">Company Information</a></li>
                        <li><a href="#">Contact us</a></li>
                    </ul>
                </div>
            </div>
        </div>
        <div class="footer-copyright" style="background: #090a14;margin-top: 0px;border-top-width: 0px;border-right-width: 0px;border-bottom-width: 0px;border-left-width: 0px;padding-top: 0px;padding-bottom: 0px;">
            <p>© 2021 Copyright Text</p>
        </div>
    </footer>
    <script src="../assets/bootstrap/js/bootstrap.min.js"></script>
    <script src="../assets/js/bs-init.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/baguettebox.js/1.10.0/baguetteBox.min.js"></script>
    <script src="../assets/js/vanilla-zoom.js"></script>
    <script src="../assets/js/theme.js"></script>
    <script src="../assets/js/redirect.js"></script>
</body>

</html>